Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zbio.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 858)
@@ -27,4 +27,5 @@
    USE p4zmeso         ! 
    USE p4zrem          ! 
+   USE prtctl_trc
    
    IMPLICIT NONE
@@ -43,5 +44,5 @@
 CONTAINS
 
-   SUBROUTINE p4z_bio
+   SUBROUTINE p4z_bio ( kt )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE p4z_bio  ***
@@ -53,14 +54,8 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      INTEGER, INTENT(in) :: kt
       INTEGER  ::   ji, jj, jk, jn
-      REAL(wp) ::   zdenom, ztemp
-      REAL(wp) ::   zprodt, zprodca
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdenom1
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zfracal
-#if defined key_kriest
-      REAL(wp) ::   znumpoc, znumdoc
-#else
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdenom2
-#endif
+      CHARACTER (len=25) :: charout
+
       !!---------------------------------------------------------------------
 
@@ -68,5 +63,5 @@
       !     OF PHYTOPLANKTON AND DETRITUS
 
-      zdiss(:,:,:) = 0.01
+      xdiss(:,:,:) = 0.01
 
 !!gm the use of nmld should be better here?
@@ -74,44 +69,9 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF( fsdepw(ji,jj,jk+1) .le. hmld(ji,jj) )   zdiss(ji,jj,jk) = 1.e0
+               IF( fsdepw(ji,jj,jk+1) .le. hmld(ji,jj) )   xdiss(ji,jj,jk) = 1.e0
             END DO 
          END DO
       END DO
 
-      ! Compute de different ratios for scavenging of iron
-      ! --------------------------------------------------
-
-      DO jk = 1, jpk
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-#if ! defined key_kriest
-               zdenom = 1. / (  trn(ji,jj,jk,jppoc) + trn(ji,jj,jk,jpgoc)           &
-                  &           + trn(ji,jj,jk,jpdsi) + trn(ji,jj,jk,jpcal) + rtrn )
-               zdenom1(ji,jj,jk) = trn(ji,jj,jk,jppoc) * zdenom
-               zdenom2(ji,jj,jk) = trn(ji,jj,jk,jpgoc) * zdenom
-#else
-               zdenom = 1. / (  trn(ji,jj,jk,jppoc)                                 &
-                  &           + trn(ji,jj,jk,jpdsi) + trn(ji,jj,jk,jpcal) + rtrn )
-               zdenom1(ji,jj,jk) = trn(ji,jj,jk,jppoc) * zdenom
-#endif
-            END DO
-         END DO
-      END DO
-
-      ! Compute the fraction of nanophytoplankton that is made of calcifiers
-      ! --------------------------------------------------------------------
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ztemp = MAX( 0., tn(ji,jj,jk) )
-               zfracal(ji,jj,jk) = caco3r * xlimphy(ji,jj,jk)   &
-                  &                       * MAX( 0.0001, ztemp / ( 2.+ ztemp ) )   &
-                  &                       * MAX( 1., trn(ji,jj,jk,jpphy) * 1.e6 / 2. )
-               zfracal(ji,jj,jk) = MIN( 0.8 , zfracal(ji,jj,jk) )
-               zfracal(ji,jj,jk) = MAX( 0.01, zfracal(ji,jj,jk) )
-            END DO
-         END DO
-      END DO
 
       ! computation of the vertical flux of particulate organic matter
@@ -122,8 +82,11 @@
       ENDIF
 
+
       ! compute the PAR in the water column
       ! -----------------------------------
 
       CALL p4z_opt       ! Optical 
+
+
 
       ! compute the co-limitations by the various nutrients
@@ -132,9 +95,12 @@
       CALL p4z_lim
 
+
       ! compute phytoplankton growth rate over the global ocean. 
       ! -------------------------------------------------------
       ! (Growth rates for each element is computed (C, Si, Fe, Chl))
 
-      CALL p4z_prod
+      CALL p4z_prod ( kt )
+
+
 
       ! phytoplankton mortality (Mortality losses for each elements are computed (C, Fe, Si, Chl) )
@@ -143,5 +109,7 @@
       CALL p4z_nano       ! nanophytoplankton
       
+
       CALL p4z_diat       ! diatoms
+
 
       ! zooplankton sources/sinks routines (each elements are computed (C, Fe, Si, Chl) )
@@ -149,6 +117,8 @@
 
       CALL p4z_micro      ! microzooplankton
+
       
       CALL p4z_meso       ! mesozooplankton
+
 
       ! computation of remineralization terms of organic matter + scavenging of Fe
@@ -158,154 +128,14 @@
 
 
-      ! Determination of tracers concentration as a function of biological sources and sinks
-      ! ------------------------------------------------------------------------------------
-
-      DO jk = 1, jpkm1
-
-         ! Evolution of PO4
-         ! ----------------    
-         trn(:,:,jk,jppo4) = trn(:,:,jk,jppo4) - prorca(:,:,jk) - prorca2(:,:,jk)            &
-            &                                  + olimi (:,:,jk) + grarem (:,:,jk) * sigma1   &
-            &                                  + denitr(:,:,jk) + grarem2(:,:,jk) * sigma2
-
-         ! Evolution of NO3 and NH4
-         ! ------------------------
-         trn(:,:,jk,jpno3) = trn(:,:,jk,jpno3) - pronew(:,:,jk) - pronew2(:,:,jk)            &
-            &                                  + onitr (:,:,jk) - denitr (:,:,jk) * rdenit
-
-         trn(:,:,jk,jpnh4) = trn(:,:,jk,jpnh4) - proreg(:,:,jk) - proreg2(:,:,jk)            &
-            &                                  + olimi (:,:,jk) + grarem (:,:,jk) * sigma1   &
-            &                                                   + grarem2(:,:,jk) * sigma2   &
-            &                                  - onitr (:,:,jk) + denitr (:,:,jk)
-
-         ! Evolution of Phytoplankton
-         ! --------------------------
-         trn(:,:,jk,jpphy) = trn(:,:,jk,jpphy) + prorca (:,:,jk) * ( 1.- excret ) - tortp(:,:,jk)   &
-            &                                  - grazp  (:,:,jk) - grazn(:,:,jk)  - respp(:,:,jk)
-
-         trn(:,:,jk,jpnch) = trn(:,:,jk,jpnch) + prorca6(:,:,jk) * ( 1.- excret ) - tortnch(:,:,jk)   &
-            &                                  - grazpch(:,:,jk) - graznch(:,:,jk)- respnch(:,:,jk)
-
-         ! Evolution of Diatoms
-         ! --------------------
-         trn(:,:,jk,jpdia) = trn(:,:,jk,jpdia) + prorca2(:,:,jk) * ( 1.- excret2 ) - tortp2(:,:,jk)   &
-            &                                  - respp2 (:,:,jk) - grazd(:,:,jk)   - grazsd(:,:,jk)
-
-         trn(:,:,jk,jpdch) = trn(:,:,jk,jpdch) + prorca7(:,:,jk) * ( 1.- excret2 ) - tortdch(:,:,jk)   &
-            &                                  - respdch(:,:,jk) - grazdch(:,:,jk) - grazsch(:,:,jk)
-
-         ! Evolution of Zooplankton
-         ! ------------------------   
-         trn(:,:,jk,jpzoo) = trn(:,:,jk,jpzoo) + epsher * ( grazp(:,:,jk) + grazm(:,:,jk) + grazsd(:,:,jk) )   &
-            &                                  - grazz(:,:,jk) - tortz(:,:,jk) - respz(:,:,jk)
-
-         ! Evolution of Mesozooplankton
-         ! ------------------------
-         trn(:,:,jk,jpmes) = trn(:,:,jk,jpmes) + epsher2 * (  grazd  (:,:,jk) + grazz  (:,:,jk) + grazn(:,:,jk)   &
-            &                                               + grazpoc(:,:,jk) + grazffe(:,:,jk)  )                &
-            &                                  - tortz2(:,:,jk) - respz2(:,:,jk)
-    
-         ! Evolution of O2
-         ! ---------------     
-         trn(:,:,jk,jpoxy) = trn(:,:,jk,jpoxy) + o2ut * (  proreg(:,:,jk) + proreg2(:,:,jk) - olimi(:,:,jk)        &
-            &                                             -grarem(:,:,jk) * sigma1 - grarem2(:,:,jk) * sigma2  )   &
-            &                                  + ( o2ut + o2nit ) * ( pronew(:,:,jk) + pronew2(:,:,jk) )           &
-            &                                  - o2nit * onitr(:,:,jk)
-
-         ! Evolution of IRON
-         ! -----------------
-         trn(:,:,jk,jpfer) = trn(:,:,jk,jpfer) + ( excret  - 1.) * prorca5(:,:,jk) - xaggdfe (:,:,jk)   &
-            &                                  + ( excret2 - 1.) * prorca4(:,:,jk) - xbactfer(:,:,jk)   &
-            &                                  + grafer(:,:,jk) + grafer2(:,:,jk)                       &
-            &                                  + ofer  (:,:,jk) - xscave (:,:,jk)
-         !
-      END DO
-
-
-#if defined key_kriest
-
-#include "p4zbio_kriest.h90"
-
-#else
-
-#include "p4zbio_std.h90"
-
-#endif
-
-
-      DO jk = 1, jpkm1
-
-         ! Evolution of biogenic Silica
-         ! ----------------------------
-         trn(:,:,jk,jpbsi) = trn(:,:,jk,jpbsi) + prorca3(:,:,jk) * ( 1.- excret2 ) - grazss(:,:,jk)   &
-            &                                  - tortds (:,:,jk) - respds(:,:,jk)  - grazs (:,:,jk)
-
-         ! Evolution of sinking biogenic silica
-         ! ------------------------------------
-         trn(:,:,jk,jpdsi) = trn(:,:,jk,jpdsi) + tortds (:,:,jk) + respds(:,:,jk)  + grazs(:,:,jk)   &
-            &                                  - osil   (:,:,jk) + grazss(:,:,jk)
-
-         ! Evolution of biogenic diatom Iron
-         ! ---------------------------------
-         trn(:,:,jk,jpdfe) = trn(:,:,jk,jpdfe) + prorca4(:,:,jk) * ( 1.- excret2 ) - grazsf(:,:,jk)   &
-            &                                  - tortdf (:,:,jk) - respdf(:,:,jk)  - grazf (:,:,jk)
-
-         ! Evolution of biogenic nanophytoplankton Iron
-         ! --------------------------------------------
-         trn(:,:,jk,jpnfe) = trn(:,:,jk,jpnfe) + prorca5(:,:,jk) * ( 1.- excret )  - graznf(:,:,jk)   &
-            &                                  - tortnf (:,:,jk) - respnf(:,:,jk)  - grazpf(:,:,jk)
-
-         ! Evolution of dissolved Silica
-         ! -----------------------------
-         trn(:,:,jk,jpsil) = trn(:,:,jk,jpsil) - ( 1.- excret2 ) * prorca3(:,:,jk) + osil(:,:,jk)
-
-      END DO
-     
-      ! Evolution of calcite and silicates as a function of the two tracers
-      ! -------------------------------------------------------------------     
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
-               zprodt  = prorca(ji,jj,jk) + prorca2(ji,jj,jk) - olimi(ji,jj,jk) - grarem(ji,jj,jk) * sigma1   &
-                  &                       - grarem2(ji,jj,jk) * sigma2 - denitr(ji,jj,jk)
-               zprodca = pronew(ji,jj,jk) + pronew2(ji,jj,jk) - onitr(ji,jj,jk) + rdenit * denitr(ji,jj,jk)
-    
-               ! potential production of calcite and biogenic silicate
-               ! ------------------------------------------------------     
-               prcaca(ji,jj,jk) = zfracal(ji,jj,jk)   &
-                  &             * (  part * (  unass*grazp(ji,jj,jk) + unass2*grazn(ji,jj,jk)  )   &
-                  &                + tortp(ji,jj,jk) + respp(ji,jj,jk)  )
-
-               ! Consumption of Total (12C)O2
-               ! ----------------------------     
-               trn(ji,jj,jk,jpdic) = trn(ji,jj,jk,jpdic) - zprodt - prcaca(ji,jj,jk)
-
-               ! Consumption of alkalinity due to ca++ uptake and increase of
-               !  alkalinity due to nitrate consumption during organic soft tissue production
-               ! ---------------------------------------------------------  
-               trn(ji,jj,jk,jptal) = trn(ji,jj,jk,jptal) + rno3 * zprodca - 2.* prcaca(ji,jj,jk)
-               !
-            END DO
-         END DO
-      END DO
-
-
-      ! Production of calcite due to biological production
-      ! --------------------------------------------------   
-      DO jk = 1, jpkm1
-         trn(:,:,jk,jpcal) = trn(:,:,jk,jpcal) + prcaca(:,:,jk)
-      END DO
-
-
       ! Loop to test if tracers concentrations fall below 0.
       ! ----------------------------------------------------
 
-      znegtr(:,:,:) = 1.e0
-      DO jn = 1, jptra
+      xnegtr(:,:,:) = 1.e0
+      DO jn = jp_pcs0, jp_pcs1
          DO jk = 1, jpk
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  IF( trn(ji,jj,jk,jn) < 0.e0 )   znegtr(ji,jj,jk) = 0.e0
+                  IF( ( trn(ji,jj,jk,jn) + tra(ji,jj,jk,jn) ) < 0.e0 )   &
+             &      xnegtr(ji,jj,jk) = 0.e0
                END DO
             END DO
@@ -314,24 +144,38 @@
       !                                ! where at least 1 tracer concentration becomes negative
       !                                ! all tracer tendancy are set to zero (i.e. trn = trb)
-      DO jn = 1, jptra
-         trn(:,:,:,jn) = trb(:,:,:,jn) + znegtr(:,:,:) * ( trn(:,:,:,jn) - trb(:,:,:,jn) )
+      DO jn = jp_pcs0, jp_pcs1
+         trn(:,:,:,jn) = trn(:,:,:,jn) + xnegtr(:,:,:) * tra(:,:,:,jn)
       END DO
 
-# if defined key_trc_dia3d
+
+      tra(:,:,:,:) = 0.0
+
+#if defined key_kriest
+        DO jk = 1,jpkm1
+           DO jj = 1,jpj
+              DO ji = 1,jpi
+                 trn(ji,jj,jk,jpnum) = MAX( trn(ji,jj,jk,jpnum),  &
+     &                                      trn(ji,jj,jk,jppoc) / xkr_massp / xnumm(jk) )
+
+                 trn(ji,jj,jk,jpnum) = MIN( trn(ji,jj,jk,jpnum),  &
+     &                                      trn(ji,jj,jk,jppoc) / xkr_massp / 1.1 )
+
+          END DO
+        END DO
+      END DO
+#endif
+
+
+# if defined key_trc_dia3d && defined key_kriest
 !!gm potential bug  hard coded index on trc3d
-          trc3d(:,:,:, 4) = etot(:,:,:)
-          trc3d(:,:,:, 5) = prorca (:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-          trc3d(:,:,:, 6) = prorca2(:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-          trc3d(:,:,:, 7) = pronew (:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-          trc3d(:,:,:, 8) = pronew2(:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-          trc3d(:,:,:, 9) = prorca3(:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-          trc3d(:,:,:,10) = prorca4(:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-#  if ! defined key_kriest
-          trc3d(:,:,:,11) = prorca5(:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-#  else
-          trc3d(:,:,:,11) = prcaca (:,:,:) * znegtr(:,:,:) * 1.e3 * rfact2r
-#  endif
+     trc3d(:,:,:,11) = tra(:,:,:,jpcal) * xnegtr(:,:,:) * 1.e3 * rfact2r
 # endif
       !
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('bio ')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=trn, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
    END SUBROUTINE p4z_bio
 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zche.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 858)
@@ -25,4 +25,155 @@
 
    PUBLIC   p4z_che    ! called in p4zprg.F90
+
+   !! * Module variables
+
+   REAL(wp) :: &
+      salchl = 1./1.80655 ! conversion factor for salinity --> chlorinity (Wooster et al. 1969)
+
+   REAL(wp) :: &            ! coeff. for apparent solubility equilibrium 
+      akcc1 = -171.9065 , &    ! Millero et al. 1995 from Mucci 1983
+      akcc2 = -0.077993 , &  
+      akcc3 = 2839.319  , &  
+      akcc4 = 71.595    , &  
+      akcc5 = -0.77712  , &  
+      akcc6 = 0.0028426 , &  
+      akcc7 = 178.34    , &  
+      akcc8 = -0.07711  , &  
+      akcc9 = 0.0041249
+
+
+   REAL(wp) :: &             ! universal gas constants
+      rgas = 83.143, &
+      oxyco = 1./22.4144
+
+   REAL(wp) :: &             ! borat constants
+      bor1 = 0.00023, &
+      bor2 = 1./10.82
+
+   REAL(wp) :: &              !
+      ca0 = -162.8301  , &
+      ca1 = 218.2968   , &
+      ca2 = 90.9241    , &
+      ca3 = -1.47696   , &
+      ca4 = 0.025695   , &
+      ca5 = -0.025225  , &
+      ca6 = 0.0049867
+
+   REAL(wp) :: &              ! coeff. for 1. dissoc. of carbonic acid (Edmond and Gieskes, 1970)   
+      c10 = -3670.7   , &
+      c11 = 62.008    , &
+      c12 = -9.7944   , &
+      c13 = 0.0118    , &
+      c14 = -0.000116
+
+   REAL(wp) :: &              ! coeff. for 2. dissoc. of carbonic acid (Millero, 1995)   
+      c20 = -1394.7   , &
+      c21 = -4.777    , &
+      c22 = 0.0184    , &
+      c23 = -0.000118
+
+   REAL(wp) :: &             ! constants for calculate concentrations 
+      st1  = 0.14     , &    ! for sulfate (Morris & Riley 1966)
+      st2  = 1./96.062, &
+      ks0  = 141.328  , &
+      ks1  = -4276.1  , &
+      ks2  = -23.093  , &
+      ks3  = -13856.  , &
+      ks4  = 324.57   , &
+      ks5  = -47.986  , &
+      ks6  = 35474.   , &
+      ks7  = -771.54  , &
+      ks8  = 114.723  , &
+      ks9  = -2698.   , &
+      ks10 = 1776.    , &
+      ks11 = 1.       , &
+      ks12 = -0.001005 
+
+   REAL(wp) :: &             ! constants for calculate concentrations 
+      ft1  = 0.000067   , &  ! fluorides (Dickson & Riley 1979 )
+      ft2  = 1./18.9984 , &
+      kf0  = -12.641    , &
+      kf1  = 1590.2     , &
+      kf2  = 1.525      , &
+      kf3  = 1.0        , &
+      kf4  =-0.001005
+
+
+   REAL(wp) :: &              ! coeff. for 1. dissoc. of boric acid (Dickson and Goyet, 1994)
+      cb0  = -8966.90, &
+      cb1  = -2890.53, &
+      cb2  = -77.942 , &
+      cb3  = 1.728   , &
+      cb4  = -0.0996 , &
+      cb5  = 148.0248, &
+      cb6  = 137.1942, &
+      cb7  = 1.62142 , &
+      cb8  = -24.4344, &
+      cb9  = -25.085 , &
+      cb10 = -0.2474 , &
+      cb11 = 0.053105
+
+   REAL(wp) :: &             ! coeff. for dissoc. of water (Dickson and Riley, 1979 )
+      cw0 = -13847.26  , &
+      cw1 = 148.9652   , &
+      cw2 = -23.6521   , &
+      cw3 = 118.67     , &
+      cw4 = -5.977     , &
+      cw5 = 1.0495     , &
+      cw6 = -0.01615
+ 
+   REAL(wp) :: &             ! coeff. for dissoc. of phosphate (Millero (1974)
+      cp10 = 115.54    , &
+      cp11 = -4576.752 , &
+      cp12 = -18.453   , &
+      cp13 = -106.736  , &
+      cp14 = 0.69171   , &
+      cp15 = -0.65643  , &
+      cp16 = -0.01844  , &
+      cp20 = 172.1033  , &
+      cp21 = -8814.715 , &
+      cp22 = -27.927   , &
+      cp23 = -160.340  , &
+      cp24 = 1.3566    , &
+      cp25 = 0.37335   , &
+      cp26 = -0.05778  , &
+      cp30 = -18.126   , &
+      cp31 = -3070.75  , &
+      cp32 = 17.27039  , &
+      cp33 = 2.81197   , &
+      cp34 = -44.99486 , &
+      cp35 = -0.09984
+
+   REAL(wp) :: &             ! coeff. for dissoc. of silicates (Millero (1974)  
+      cs10 = 117.385   , &  
+      cs11 = -8904.2   , & 
+      cs12 = -19.334   , & 
+      cs13 = -458.79   , & 
+      cs14 = 3.5913    , & 
+      cs15 = 188.74    , & 
+      cs16 = -1.5998   , & 
+      cs17 = -12.1652  , & 
+      cs18 = 0.07871   , & 
+      cs19 = 0.        , & 
+      cs20 = 1.        , & 
+      cs21 = -0.001005
+
+   REAL(wp) :: &              ! volumetric solubility constants for o2 in ml/l (Weiss, 1974)
+      ox0 = -58.3877   , &
+      ox1 = 85.8079    , &
+      ox2 = 23.8439    , &
+      ox3 = -0.034892  , &
+      ox4 = 0.015568   , &
+      ox5 = -0.0019387 
+
+   REAL(wp), DIMENSION(5)  :: &  ! coeff. for seawater pressure correction 
+      devk1, devk2, devk3,    &  ! (millero 95)
+      devk4, devk5
+
+   DATA devk1 / -25.5    , -15.82    , -29.48  , -25.60     , -48.76    /   
+   DATA devk2 / 0.1271   , -0.0219   , 0.1622  , 0.2324     , 0.5304    /   
+   DATA devk3 / 0.       , 0.        , 2.608E-3,  -3.6246E-3, 0.        /   
+   DATA devk4 / -3.08E-3 , 1.13E-3   , -2.84E-3, -5.13E-3   , -11.76E-3 /   
+   DATA devk5 / 0.0877E-3, -0.1475E-3,  0.     , 0.0794E-3  , 0.3692E-3 /
 
    !!* Substitution
@@ -46,16 +197,16 @@
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   ztkel, zsal , zqtt  , zbuf1 , zbuf2
-      REAL(wp) ::   zpres, ztc  , zcl   , zcpexp, zcek0, zoxy  , zcpexp2
+      REAL(wp) ::   zpres, ztc  , zcl   , zcpexp, zoxy  , zcpexp2
       REAL(wp) ::   zsqrt, ztr  , zlogt , zcek1
       REAL(wp) ::   zlqtt, zqtt2, zsal15, zis   , zis2 , zisqrt
       REAL(wp) ::   zckb , zck1 , zck2  , zckw  , zak1 , zak2  , zakb , zaksp0, zakw
-      REAL(wp) ::   zckp1, zckp2, zckp3 , zcksi , zakp1, zakp2 , zakp3, zaksi
-      REAL(wp) ::   zst  , zft  , zcks  , zckf  , zaks , zakf  , zaksp1
+      REAL(wp) ::   zst  , zft  , zcks  , zckf  , zaksp1
       !!---------------------------------------------------------------------
 
       ! CHEMICAL CONSTANTS - SURFACE LAYER
       ! ----------------------------------
-
+!CDIR NOVERRCHK
       DO jj = 1, jpj
+!CDIR NOVERRCHK
          DO ji = 1, jpi
 
@@ -69,5 +220,4 @@
             !                             ! LN(K0) OF SOLUBILITY OF CO2 (EQ. 12, WEISS, 1980)
             !                             !     AND FOR THE ATMOSPHERE FOR NON IDEAL GAS
-            zcek0 = c00 + c01 / zqtt + c02 * zlqtt + zsal * ( c03 + c04 * zqtt + c05 * zqtt2 )
             zcek1 = ca0 + ca1 / zqtt + ca2 * zlqtt + ca3 * zqtt2 + zsal*( ca4 + ca5 * zqtt + ca6 * zqtt2 )
 
@@ -76,7 +226,6 @@
 
             !                             ! SET SOLUBILITIES OF O2 AND CO2
-            chemc(ji,jj,1) = EXP( zcek0 ) * 1.e-6 * rhop(ji,jj,1) / 1000.
+            chemc(ji,jj,1) = EXP( zcek1 ) * 1.e-6 * rhop(ji,jj,1) / 1000.
             chemc(ji,jj,2) = EXP( zoxy  ) * oxyco
-            chemc(ji,jj,3) = EXP( zcek1 ) * 1.e-6 * rhop(ji,jj,1) / 1000.
 
          END DO
@@ -85,7 +234,9 @@
       ! CHEMICAL CONSTANTS - DEEP OCEAN
       ! -------------------------------
-
+!CDIR NOVERRCHK
       DO jk = 1, jpk
+!CDIR NOVERRCHK
          DO jj = 1, jpj
+!CDIR NOVERRCHK
             DO ji = 1, jpi
 
@@ -136,11 +287,4 @@
                zckw    = cw0 * ztr + cw1 + cw2 * zlogt + ( cw3 * ztr + cw4 + cw5 * zlogt ) * zsqrt + cw6 * zsal
 
-               ! DISSOCIATION CONSTANT FOR PHOSPHATE AND SILICATE (seawater scale)
-               zckp1 = cp10 + cp11 * ztr + cp12 * zlogt + zsqrt * ( cp13 * ztr + cp14 ) + zsal * ( cp15 * ztr + cp16 )
-               zckp2 = cp20 + cp21 * ztr + cp22 * zlogt + zsqrt * ( cp23 * ztr + cp24 ) + zsal * ( cp25 * ztr + cp26 )
-               zckp3 = cp30 + cp31 * ztr                + zsqrt * ( cp32 * ztr + cp33 ) + zsal * ( cp34 * ztr + cp35 )
-               zcksi = cs10 + cs11 * ztr + cs12 * zlogt + zisqrt* ( cs13 * ztr + cs14 ) + zis * ( cs15 * ztr + cs16 )  &
-                  &                                    + zis2  * ( cs17 * ztr + cs18 ) + LOG( 1.   + cs19 * zsal )     &
-                  &                                                                    + LOG( cs20 + cs21 * zsal )
 
                ! APPARENT SOLUBILITY PRODUCT K'SP OF CALCITE IN SEAWATER
@@ -153,12 +297,6 @@
                zak2    = 10**(zck2)
                zakb    = EXP( zckb  )
-               zakp1   = EXP( zckp1 )
-               zakp2   = EXP( zckp2 )
-               zakp3   = EXP( zckp3 )
-               zaksi   = EXP( zcksi )
                zakw    = EXP( zckw )
                zaksp1  = 10**(zaksp0)
-               zaks    = exp( zcks )
-               zakf    = exp( zckf )
 
                ! FORMULA FOR CPEXP AFTER EDMOND & GIESKES (1970)
@@ -178,56 +316,29 @@
                !        CORRECTION AFTER CULBERSON AND PYTKOWICZ (1968)
                !        (CF. BROECKER ET AL., 1982)
+
+               zbuf1  = -(devk1(1)+devk2(1)*ztc+devk3(1)*ztc*ztc)
+               zbuf2  = 0.5*(devk4(1)+devk5(1)*ztc)
+               ak13(ji,jj,jk) = zak1 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
+
+               zbuf1  =     - ( devk1(2) + devk2(2) * ztc + devk3(2) * ztc * ztc )
+               zbuf2  = 0.5 * ( devk4(2) + devk5(2) * ztc )
+               ak23(ji,jj,jk) = zak2 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
+
                zbuf1  =     - ( devk1(3) + devk2(3) * ztc + devk3(3) * ztc * ztc )
                zbuf2  = 0.5 * ( devk4(3) + devk5(3) * ztc )
                akb3(ji,jj,jk) = zakb * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
 
-               zbuf1  = -(devk1(1)+devk2(1)*ztc+devk3(1)*ztc*ztc)
-               zbuf2  = 0.5*(devk4(1)+devk5(1)*ztc)
-               ak13(ji,jj,jk) = zak1 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
-
-               zbuf1  =     - ( devk1(2) + devk2(2) * ztc + devk3(2) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(2) + devk5(2) * ztc )
-               ak23(ji,jj,jk) = zak2 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
-
                zbuf1  =     - ( devk1(4) + devk2(4) * ztc + devk3(4) * ztc * ztc )
                zbuf2  = 0.5 * ( devk4(4) + devk5(4) * ztc )
-               akp13(ji,jj,jk) = zakp1 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
-
-               zbuf1  =     - ( devk1(5) + devk2(5) * ztc + devk3(5) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(5) + devk5(5) * ztc )
-               akp23(ji,jj,jk) = zakp2 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
-
-               zbuf1  =     - ( devk1(6) + devk2(6) * ztc + devk3(6) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(6) + devk5(6) * ztc )
-               akp33(ji,jj,jk) = zakp3 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
-
-               zbuf1  =     - ( devk1(7) + devk2(7) * ztc + devk3(7) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(7) + devk5(7) * ztc )
                akw3(ji,jj,jk) = zakw * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
 
-               !  Ksi
-               !            aksi3(ji,jj,jk) = zaksi
-               !
-               !  Or using coefficient of borates (cf millero 95+ corrected version html doc co2sys)
-               !  "deltaVsi and deltaKsi have been estimated from the value of boric acid"
-               zbuf1  =     - ( devk1(3) + devk2(3) * ztc + devk3(3) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(3) + devk5(3) * ztc )
-               aksi3(ji,jj,jk) = zaksi * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
 
                ! APPARENT SOLUBILITY PRODUCT K'SP OF CALCITE 
                !        AS FUNCTION OF PRESSURE FOLLOWING MILLERO
                !        (P. 1285) AND BERNER (1976)
-               zbuf1  =     - ( devk1(8) + devk2(8) * ztc + devk3(8) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(8) + devk5(8) * ztc )
+               zbuf1  =     - ( devk1(5) + devk2(5) * ztc + devk3(5) * ztc * ztc )
+               zbuf2  = 0.5 * ( devk4(5) + devk5(5) * ztc )
                aksp(ji,jj,jk) = zaksp1 * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
 
-               !  Pressure correction for sulfate and fluoride
-               zbuf1  =     - ( devk1(9) + devk2(9) * ztc + devk3(9) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(9) + devk5(9) * ztc )
-               aks3(ji,jj,jk) = zaks   * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
-
-               zbuf1  =     - ( devk1(10) + devk2(10) * ztc + devk3(10) * ztc * ztc )
-               zbuf2  = 0.5 * ( devk4(10) + devk5(10) * ztc )
-               akf3(ji,jj,jk) = zakf   * EXP( zbuf1 * zcpexp + zbuf2 * zcpexp2 )
 
                ! TOTAL BORATE CONCENTR. [MOLES/L]
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zdiat.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zdiat.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zdiat.F90	(revision 858)
@@ -16,4 +16,5 @@
    USE trp_trc         ! 
    USE sms             ! 
+   USE prtctl_trc
 
    IMPLICIT NONE
@@ -40,6 +41,9 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zfact, zstep, zcompadi
+      INTEGER  ::  ji, jj, jk
+      REAL(wp) ::  zfactfe,zfactsi,zfactch, zstep, zcompadi
+      REAL(wp) ::  zrespp2, ztortp2, zmortp2
+      CHARACTER (len=25) :: charout
+ 
       !!---------------------------------------------------------------------
 
@@ -57,5 +61,4 @@
 
                zcompadi = MAX( ( trn(ji,jj,jk,jpdia) - 1e-8), 0. )
-               zfact    = 1. / ( trn(ji,jj,jk,jpdia) + rtrn )
 
 !    Aggregation term for diatoms is increased in case of nutrient
@@ -64,34 +67,52 @@
 !     ------------------------------------------------------------
 
-               respp2 (ji,jj,jk) = 1.e6 * zstep * (  wchl + wchld * ( 1.- xlimdia(ji,jj,jk) )  )    &
+               zrespp2  = 1.e6 * zstep * (  wchl + wchld * ( 1.- xlimdia(ji,jj,jk) )  )    &
 # if defined key_off_degrad
-                  &              * facvol(ji,jj,jk)       &
+                  &       * facvol(ji,jj,jk)       &
 # endif
-                  &              * zdiss(ji,jj,jk) * zcompadi * trn(ji,jj,jk,jpdia)
+                  &       * xdiss(ji,jj,jk) * zcompadi * trn(ji,jj,jk,jpdia)
                                                                                
-               respds (ji,jj,jk) = respp2(ji,jj,jk) * trn(ji,jj,jk,jpbsi) * zfact
-
-               respdf (ji,jj,jk) = respp2(ji,jj,jk) * trn(ji,jj,jk,jpdfe) * zfact
-                                                                               
-               respdch(ji,jj,jk) = respp2(ji,jj,jk) * trn(ji,jj,jk,jpdch) * zfact
 
 !     Phytoplankton mortality. 
 !     ------------------------
-               tortp2 (ji,jj,jk) = mprat2 * zstep * trn(ji,jj,jk,jpdia)     &
+               ztortp2  = mprat2 * zstep * trn(ji,jj,jk,jpdia)     &
 # if defined key_off_degrad
-                  &              * facvol(ji,jj,jk)       &
+                  &        * facvol(ji,jj,jk)       &
 # endif
-                  &              / ( xkmort + trn(ji,jj,jk,jpdia) ) * zcompadi
+                  &      / ( xkmort + trn(ji,jj,jk,jpdia) ) * zcompadi
 
-               tortds (ji,jj,jk) = tortp2(ji,jj,jk) * trn(ji,jj,jk,jpbsi) * zfact
+                zmortp2 = zrespp2 + ztortp2
 
-               tortdf (ji,jj,jk) = tortp2(ji,jj,jk) * trn(ji,jj,jk,jpdfe) * zfact
+!   Update the arrays tra which contains the biological sources and sinks
+!   ---------------------------------------------------------------------
+               zfactch = trn(ji,jj,jk,jpdch) / ( trn(ji,jj,jk,jpdia) + rtrn )
+               zfactfe = trn(ji,jj,jk,jpdfe) / ( trn(ji,jj,jk,jpdia) + rtrn )
+               zfactsi = trn(ji,jj,jk,jpbsi) / ( trn(ji,jj,jk,jpdia) + rtrn )
 
-               tortdch(ji,jj,jk) = tortp2(ji,jj,jk) * trn(ji,jj,jk,jpdch) * zfact
-
+               tra(ji,jj,jk,jpdia) = tra(ji,jj,jk,jpdia) - zmortp2 
+               tra(ji,jj,jk,jpdch) = tra(ji,jj,jk,jpdch) - zmortp2 * zfactch
+               tra(ji,jj,jk,jpdfe) = tra(ji,jj,jk,jpdfe) - zmortp2 * zfactfe
+               tra(ji,jj,jk,jpbsi) = tra(ji,jj,jk,jpbsi) - zmortp2 * zfactsi
+               tra(ji,jj,jk,jpdsi) = tra(ji,jj,jk,jpdsi) + zmortp2 * zfactsi
+#if defined key_kriest
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zmortp2  
+               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + ztortp2 * xkr_ndiat + zrespp2 * xkr_naggr
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zmortp2 * zfactfe
+#else
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zrespp2 + 0.5 * ztortp2
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + 0.5 * ztortp2
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + 0.5 * ztortp2 * zfactfe
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + ( zrespp2 + 0.5 * ztortp2 ) * zfactfe
+#endif
             END DO
          END DO
       END DO
       !
+        IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('diat')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+             
    END SUBROUTINE p4z_diat
 
